Page MenuHomePhabricator

Support ConfirmEdit captchas in DiscussionTools
Closed, ResolvedPublic

Description

When a non-logged-in or new users makes an edit that adds new external links, they are required to fill in a captcha:


The same applies for edits to talk pages. However, we haven't built an interface for this in DiscussionTools, so all you get is an error "Invalid response from server.":

Event Timeline

matmarex created this task.Mar 12 2020, 1:33 PM
Restricted Application added a subscriber: Aklapper. · View Herald TranscriptMar 12 2020, 1:33 PM

Change 582944 had a related patch set uploaded (by Bartosz Dziewoński; owner: Bartosz Dziewoński):
[mediawiki/extensions/DiscussionTools@master] ConfirmEdit CAPTCHA support

https://gerrit.wikimedia.org/r/582944

Proposed design: (I didn't think about it too much, and tried to use standard components)

The CAPTCHA box only appears after trying to submit the post and getting an error from the API (as filling it out is usually only required when adding some external links).

I talked with @iamjessklein about this, in summary the design seems okay (at least for the first iteration), but we're a bit worried about confusing the user with too many boxes.

Particularly, I thought that it's possible we would display three at once (CAPTCHA, red error at the top, yellow anon warning underneath), but I tried it for a bit and that's actually not possible – you can't get an error message and the CAPTCHA at the same time. So maybe it's alright as it is?

ppelberg added a subscriber: ppelberg.EditedMar 26 2020, 1:22 AM

Particularly, I thought that it's possible we would display three at once (CAPTCHA, red error at the top, yellow anon warning underneath), but I tried it for a bit and that's actually not possible – you can't get an error message and the CAPTCHA at the same time. So maybe it's alright as it is?

@matmarex, assuming F31699571 is what people will end up seeing then, +1 to what you and @iamjessklein came to: the current treatment looks good to me for a first iteration with the follow caveats:

  • 1. Are you able to deactivate the "Reply" button, as we've done in T246058, until after the person successfully completes the captcha? I wonder whether the current treatment will cause people to assume the captcha is optional and attempt to publish their comment without having completed it and become confused when they cannot.
  • 2. Are you able to change the captcha error message to "To publish your comment, please enter the words that appear in the box below (more info):" When possible, I would like for us to adapt generic copy to the talk pages context so as to reinforce the distinction in peoples' minds between talk pages and content pages.

@iamjessklein are you able to describe the refinements you and Bartosz discussed making in a future iteration in this ticket: T248594?


EDIT: filed shell ticket for design refinements.

Esanders added a subscriber: Esanders.

Added these questions to the design ticket so we can proceed with the current version which is functional.

Change 582944 merged by jenkins-bot:
[mediawiki/extensions/DiscussionTools@master] ConfirmEdit CAPTCHA support

https://gerrit.wikimedia.org/r/582944

ppelberg closed this task as Resolved.May 21 2020, 11:37 PM
ppelberg claimed this task.